#ifdef TOS
/*{{{  bd-fs*/
#define _POSIX_PATH_MAX 255
void putw(int w, FILE *s);
int getw(FILE *s);

typedef long                    off_t;
typedef unsigned long   ino_t;

struct dirent {
       long            d_ino;          /* garbage under TOS */
       off_t           d_off;          /* in TOS, entry in list */
       short           d_reclen;
       struct dirent   *d_next;        /* unique to TOS */
       char            d_name[1];
};

typedef struct _DIR {
       struct dirent *D_list;          /* list of directory entries */
       struct dirent *D_curpos;        /* current position in list  */
} DIR;

#define DIRENTSIZ(x) (sizeof(struct dirent) + (x) + 1)

DIR            *opendir(const char *dirname);
struct dirent  *readdir(DIR *dirp);
off_t          telldir(DIR *dirp);
void           seekdir(DIR *dirp, off_t loc);
void           rewinddir(DIR *dirp);
int            closedir(DIR *dirp);

#  define S_IRUSR (0)
#  define S_IRGRP (0)
#  define S_IROTH (256)
#  define S_ISDIR(a) (a & 16)
#  define S_ISREG(a) ((a & 16)==0)
#  define getuid() (1)
#  define getgid() (1)
#include "..\tos\xarg.h"
/*}}}  */
#endif
