/* cpp-makefile for Origami
   Use the following symbols to generate a makefile for your system by
   using /usr/lib/cpp -DSYMBOL Makefile.cpp >Makefile

   MINIX_ACKi86
   MINIX_ACKm68
   SUNOS

*/

#ifdef MINIX_ACKi86
CC=		cc
CFLAGS=		-O -D_MINIX -D_POSIX_SOURCE
LDFLAGS=	-i -T/usr/tmp
LIBS=		
O=		s
#endif

#ifdef MINIX_BCCi86
CC=		bcc
CFLAGS=		-O -D_MINIX -D_POSIX_SOURCE
LDFLAGS=
LIBS=
O=		o
#endif

#ifdef MINIX_ACKm68
/* Warning: This will probably not work! */
CC=		cc
CFLAGS=		-O -D_MINIX -D_POSIX_SOURCE
LDFLAGS=	-T/usr/tmp
LIBS=		
O=		o
#endif

#ifdef SUNOS
CC=		cc
CFLAGS=		-O -I.. -DNO_MSG -D_POSIX_SOURCE
LDFLAGS=	-s
LIBS=		-ltermcap
O=		o
#endif

HDRS=		../common/keys.h ../common/rcformat.h fold_os.h

SRCS=		main.c

OBJS=		main.$(O)

folder:		$(OBJS)
		$(CC) $(LDFLAGS) -o $@ $(OBJS) $(LIBS)

$(OBJS):	$(HDRS)


clean:
		rm -f core folder $(OBJS)
