/* cpp-makefile for Origami
   Use the following symbols to generate a makefile for your system by
   using /usr/lib/cpp -DSYMBOL Makefile.cpp >Makefile
   The following machines are currently supported:

   MINIX_ACKi86
   MINIX_BCCi86
   MINIX_ACKm68
   SUNOS

   The following CFLAGS are supported:

   SHORT_NAMES  for only 7 significant characters in indentifiers
*/

#ifdef MINIX_ACKi86
CC=		cc
CFLAGS=		-O -DSHORT_NAMES -D_MINIX -D_POSIX_SOURCE
LDFLAGS=	-i -T/usr/tmp
LIBS=		
O=		s
#endif

#ifdef MINIX_BCCi86
CC=		bcc
CFLAGS=		-O -D_MINIX -D_POSIX_SOURCE
LDFLAGS=
LIBS=
O=		o
#endif

#ifdef MINIX_ACKm68
/* Warning: This will probably not work! */
CC=		cc
CFLAGS=		-O
LDFLAGS=	-T/usr/tmp
LIBS=		
O=		o
#endif

#ifdef SUNOS
CC=		cc
CFLAGS=		-I.. -O -D_POSIX_SOURCE
LDFLAGS=	-s
LIBS=		-ltermcap
O=		o
#endif

HDRS=		../common/rcformat.h ../common/keys.h keybind.h \
		../common/os.h short.h

SRCS=		codehelp.c keybind.c keytab.c messages.c name.c parsecond.c \
		parsemac.c parser.c scanner.c fileio.c

OBJS=		codehelp.$(O) keybind.$(O) keytab.$(O) messages.$(O) \
		name.$(O) parsecond.$(O) parsemac.$(O) parser.$(O) scanner.$(O)

keybind:        $(OBJS)
		$(CC) $(LDFLAGS) -o $@ $(OBJS) $(LIBS)
		
$(OBJS):	$(HDRS)

clean:
		rm -f core keybind $(OBJS)
