/* cpp-makefile for Origami
   Use the following symbols to generate a makefile for your system by
   using /usr/lib/cpp -DSYMBOL Makefile.cpp >Makefile
   The following machines are currently supported:

   MINIX_ACKi86
   MINIX_BCCi86
   MINIX_ACKm68
   SUNOS
*/

#ifdef MINIX_ACKi86
CC=		cc
CFLAGS=		-O -D_MINIX -D_POSIX_SOURCE
LDFLAGS=	-i -T/usr/tmp
LIBS=		
O=		s
#endif

#ifdef MINIX_BCCi86
CC=		bcc
CFLAGS=		-O -D_MINIX -D_POSIX_SOURCE
LDFLAGS=
LIBS=
O=		o
#endif

#ifdef MINIX_ACKm68
/* Warning: This will probably not work! */
CC=		cc
CFLAGS=		-O
LDFLAGS=	-T/usr/tmp
LIBS=		
O=		o
#endif

#ifdef SUNOS
CC=		cc
CFLAGS=		-I.. -O -D_POSIX_SOURCE
LDFLAGS=	-s
LIBS=		
O=		o
#endif

HDRS=		

SRCS=		viewrc.c

OBJS=		viewrc.$(O)

viewrc:		$(OBJS)
		$(CC) $(LDFLAGS) -o $@ $(OBJS) $(LIBS)
		
$(OBJS):	$(HDRS)

clean:
		rm -f core viewrc $(OBJS)
